#include <stddef.h>
#include <conio.h>
#include <string.h>

#include "drv.h"
#include "wc_dd.h"



#pragma pack (0);                         // Important statement!

const DEVICEHDR devhdr =
{
  (void far *) 0xFFFFFFFF,
  (DAW_CHR | DAW_LEVEL1 | DAW_OPN),
  (void near *) STRATEGY,                 // Pointer to ASM-routine that
  (void near *) 0,                        // calls C_Main
  "WC_DD$  ",
  0,0,0,0,0,0,0,0,
  0xADDE3219                              // This value does not have a
};                                        // meaning here...



//Ŀ
//                                                                          
// All variables must be initialized here. (Uninitialized variables are     
// placed behind the initialized ones by the linker. But we want to discard 
// variables not needed except for Initialization.                          
//                                                                          
//

FPFUNCTION DevHlp       = 0;              // Pointer to Device-Helper-Fctn.
unsigned short counter  = 0;



//Ŀ
//                                                                          
// All variables declared after this point will be erased after completion  
// of startup-code (see Function: Init(...)                                 
//                                                                          
//

char StartMsg1[] = "Sample Device Driver for OS/2 2.x and 3.x written for Watcom, Canada\n\r";
char StartMsg2[] = "Compiled ("__DATE__").\n\n\r";
char CopyrightMsg[] = "(C) 1994 FW Hard- und Software. All rights reserved.\n\n\r";
char FailTimerMsg[] = "Could not install timer handler...\n\n\r";
char CRLF[] = "\n\r";



//Ŀ
//                                                                          
// Assembler-Pragmas for two Device-Helper Funktions:                       
//                                                                          
// 1.) int DevBeep(unsigned short frequency, unsigned short duration)       
// 2.) int DevSetTimer( (PFUNCTION) &TimerHandler) )                        
//                                                                          
// (Device-Helper-Functions use register based calling conventions... so we 
//  have to provide a kind of interface to C-language).                     
//                                                                          
//

#pragma aux DevBeep = \
            "mov dl,52h" \
            "call [DevHlp]" \
            parm [bx] [cx] \
            modify [ BX CX DL ];

#pragma aux DevSetTimer = \
            "mov dl,1Dh" \
            "call [DevHlp]" \
            "pushf" \
            "pop ax" \
            "and ax,0001h" \
            parm [ax] \
            modify [ AX DL ];



//Ŀ
//                                                                          
// Main...                                                                  
//                                                                          
//

#pragma aux __CMain "*";
#pragma entry(__CMain);

unsigned int __CMain(PREQPACKET rp)
{
  switch(rp->RPcommand)
  {
    case RPINIT:
    {
      return Init(rp);
    }

    default:
    {
      return(RPDONE | RPERR | ERROR_BAD_COMMAND );
    }
  }
}



//Ŀ
//                                                                          
// timer-handler is called every 31.25ms (32Hz)                             
//                                                                          
//

void        timer_handler(void)
{
  counter++;

  if(counter >= 9*FREQ)                   // Beep every 9 seconds
  {
    counter = 0;
    DevBeep(666,39);                      // Beep....
  }
}



//Ŀ
//                                                                          
// Init-Routine... will be discarded after startup (see end of Init)        
// (Every Function after Init will be discarded).                           
//                                                                          
//

unsigned int Init(PREQPACKET rp)
{
  char *par;


  DevHlp = rp->s.Init.DevHlp;             // Pointer to Device-Helper-Fctn

  par = rp->s.Init.args;

  DosPutMessage(1, sizeof(CRLF), CRLF);
  DosPutMessage(1, strlen(par), par);     // Print out Argument line
                                          // from File CONFIG.SYS
  DosPutMessage(1, sizeof(CRLF), CRLF);
  DosPutMessage(1, sizeof(CRLF), CRLF);

  if( DevSetTimer(TIM_HNDLR) )            // Set Timer handler
  {
    DosPutMessage(1, sizeof(FailTimerMsg), FailTimerMsg);
    rp->s.InitExit.finalCS = 0;
    rp->s.InitExit.finalDS = 0;
    return(RPDONE | RPERR | ERROR_GEN_FAILURE);
  }
  else
  {
    DosPutMessage(1, sizeof(StartMsg1), StartMsg1);
    DosPutMessage(1, sizeof(StartMsg2), StartMsg2);
    DosPutMessage(1, sizeof(CopyrightMsg), CopyrightMsg);

    rp->s.InitExit.units = 0;
    rp->s.InitExit.finalCS = (void near *)Init;      // Return end of Code-Segment
    rp->s.InitExit.finalDS = (void near *)StartMsg1; // Return end of Data-Segment
    return(RPDONE);
  }
}